# -*- coding: UTF-8 -*-

'''
SVPlayer configuration file.

(c) 2011-2014 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>     

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
'''

import socket, os
from media import *

# Screensaver configuration
#screensaver = gnome_screensaver_command()
#screensaver = gnome2_screensaver_dbus()
screensaver = gnome3_screensaver_dbus()

# Window default size
window_default_size = [700, 480]

switch_source_no_signal = 5
switch_source_errors = 10

snapshot_path = "/dev/shm"
web_remote_control = ('', 9080)
remote_guide = "http://m.tv.sms.cz/"
espeak_voice = "europe/sk"

# default deinterlace for HD streams
dd = dict(deinterlace="discard")

# DVB-T frequencies
f506 = dict(
  frequency=506000000,
  inversion=2,
  bandwidth=8,
  code_rate_hp=2,
  code_rate_lp=0,
  modulation=64,
  transmission=8,
  guard=4,
  hierarchy=-1
)
f706 = dict(
  frequency=706000000
)
f474 = dict(
  frequency=474000000
)
f746 = dict(
  frequency=746000000
)
f778 = dict(
  frequency=778000000,
  inversion=-1,		#auto, 2
  bandwidth=8,		#8MHz
  #code_rate_hp=2,
  #code_rate_lp=0,
  modulation='64QAM',	#QAM-64, 64
  transmission=8,	#8K
  guard='1/4',		#1/4
  hierarchy=0		#None, -1
)
#f818 = dict(
#  frequency=818000000,
#  inversion=2,
#  bandwidth=8,
#  code_rate_hp=9,
#  code_rate_lp=9,
#  modulation=0,
#  transmission=0,
#  guard=0,
#  hierarchy=0
#)

# Radio channels
RADIO = [
  multi('Expres',
    media('MP3', 'http://85.248.7.162:8000/96.mp3'),
    media("AAC", "icyx://85.248.7.162:8000/48.aac"),
    multicast("", "rtp://@232.232.79.11:5004"),
  ),
  pls_playlist('EuroDance', 'http://listen.di.fm/public3/eurodance.pls'),
  multicast("Funradio", "rtp://@232.232.79.32:5004"),
  multicast("Europa2", "rtp://@232.232.79.13:5004"),
  multicast("Viva radio", "rtp://@232.232.79.14:5004"),
  multicast("Hornet rádio", "rtp://@232.232.79.16:5004"),
  multicast("Jemné Melódie", "rtp://@232.232.79.17:5004"),
  multicast("Hey!", "rtp://@232.232.79.18:5004"),
  multicast("Lumen", "rtp://@232.232.79.19:5004"),
  multicast("Hit FM", "rtp://@232.232.79.20:5004"),
  multicast("ČRO1 - Radiožurnál", "rtp://@232.232.79.21:5004"),
  multicast("ČRO2 - Praha", "rtp://@232.232.79.22:5004"),
  multicast("ČRO3 - Vltava", "rtp://@232.232.79.23:5004"),
  multicast("ČRO - D-dur", "rtp://@232.232.79.24:5004"),
  multicast("ČRO - Leonardo", "rtp://@232.232.79.25:5004"),
  multicast("ČRO - Česko", "rtp://@232.232.79.26:5004"),
  multicast("ČRO - Wave", "rtp://@232.232.79.27:5004"),
  multicast("ČRO - Proglas", "rtp://@232.232.79.28:5004"),
  multicast("ČRO - Region", "rtp://@232.232.79.29:5004"),
  multicast("Radio BBC CZ", "rtp://@232.232.79.30:5004"),
  multicast("Rádio 7", "rtp://@232.232.79.31:5004"),
  multicast("G-Radio", "rtp://@232.232.79.33:5004"),
  multicast("Rádio Košice", "rtp://@232.232.79.12:5004"),
  multicast("Danceradio CZ", "rtp://@232.232.79.15:5004"),
  multi("SRO1 - Slovensko",
    dvbt(u"", "Slovensko", 3011, **f506),
    multicast("", "rtp://@232.232.79.1:5004"),
  ),
  multi("SRO2 - Regina Košice",
    dvbt(u"", "ReginaKE", 3014, **f506),
    multicast("", "rtp://@232.232.79.2:5004"),
  ),
  multi("SRO2 - Regina Banská Bystrica",
    dvbt(u"", "ReginaBB", 3013, **f506),
    multicast("", "rtp://@232.232.79.3:5004"),
  ),
  multi("SRO2 - Regina Bratislava",
    dvbt(u"", "ReginaBA", 3012, **f506),
    multicast("", "rtp://@232.232.79.4:5004"),
  ),
  multi("SRO3 - Devín",
    dvbt(u"", "Devin", 3015, **f506),
    multicast("", "rtp://@232.232.79.6:5004"),
  ),
  multi("SRO4 - _FM",
    dvbt(u"", "Radio_FM", 3016, **f506),
    multicast("", "rtp://@232.232.79.7:5004"),
  ),
  multi("SRO5 - Patria",
    dvbt(u"", "PatriaFM", 3020, **f506),
    dvbt(u"", "PatriaRD", 3021, **f506),
    multicast("", "rtp://@232.232.79.5:5004"),
  ),
  multi("SRO6 - Slovakia International",
    dvbt(u"", "Slovakia", 3022, **f506),
    multicast("", "rtp://@232.232.79.8:5004"),
  ),
  multi("SRO7 - Klasika",
    dvbt(u"", "Klasika", 3017, **f506),
    multicast("", "rtp://@232.232.79.9:5004"),
  ),
  multi("SRO8 - Litera",
    dvbt(u"", "Litera", 3018, **f506),
    multicast("", "rtp://@232.232.79.10:5004"),
  ),
  dvbt(u"Junior", "Junior", 3019, **f506),
]

if os.environ.get("udpxy"):
  class antik(media):
    '''
    Redirect ANTIK channels over udpxy on router.
    Usage: udpxy=http://192.168.1.1:9000 svplayer
    '''
    source = "ANTIK:udpxy"
    url_format = os.environ['udpxy']+"/udp/%s/"
    def __init__(self, name, url, port=5004, **kw):
        url = "%s:%d" % (url, port)
        media.__init__(self, name, url, **kw)

# Channels for childrens
CHILDREN = [
  # rozpravky
  #v4l2("Minimax", 631250),
  antik('KIX', "232.232.64.69"),
  antik('Pop', "232.232.64.70"),
  antik('Tiny Pop', "232.232.64.71"),
  antik('Tiny Pop +1', "232.232.64.72"),
  antik('Duck TV', "232.232.65.73"),
  antik('Cartoon Network / TCM', "232.232.65.70"),
  antik('POP', "232.232.64.70"),
  antik('Nickelodeon', "232.232.64.140"),
  multi('Disney Channel',
    antik('', "232.232.69.3", lang=['sk', 'hu', 'Magyar', 'cs', 'Čeština']),
    antik_archive('', 72)
  ),
  multi('Disney Junior',
    antik("", "232.232.65.67", lang=['sk', 'en', 'hu', 'cs']),
  ),
  multi('Jim Jam',
    antik("", "232.232.69.2", lang=['sk', 'hu', 'Magyar', 'cs', 'Čeština']),
    guide("Jim Jam"),
  ),
]

# Other channels
BASIC = [
  # Slovak
  multi(u"Markíza",
    dvbt(u"", "Markiza", 2003, lang=['sk'], **f778),
    antik(u'', "232.232.64.200", lang=['sk']),
    #dvbt(u"Markíza", 1006, **f818),
    antik(u"HD", "232.232.64.87", **dd),
    #antik_archive(u'', 17),
    guide(u"Markiza"),
  ),
  multi(u"JOJ",
    dvbt(u"", "TV JOJ", 2001, **f778),
    antik(u'', "232.232.64.254"),
    #dvbt(u"", 1001, **f818),
    antik(u"HD", "232.232.64.5", **dd),
    antik_archive(u'', 20),
    guide(u"JOJ"),
  ),
  multi(u'TA3',
    dvbt(u"", "TA3", 2005, **f778),
    antik(u"", "232.232.64.250"),
    guide(u'TA3'),
  ),
  multi(u"Dajto",
    dvbt("", "DAJTO", 1002, **f706),
    antik("", "232.232.64.18"),
    guide("Dajto"),
  ),
  
  # Czech
  multi('AXN',
    antik("", "232.232.65.75"),
    guide('AXN'),
  ),
  multi('Film+',
    antik("", "232.232.65.66"),
    guide("Film+"),
  ),
  multi("WAU",
    dvbt("", "WAU", 1001, **f706),
    antik("", "232.232.64.25"),
    antik("HD", "232.232.64.26", **dd),
    guide("WAU"),
  ),
  multi('Prima family',
    antik('', "232.232.64.53"),
    antik_archive('', 23),
    guide("Prima family"),
  ),
  multi('Prima COOL',
    antik('', "232.232.64.65"),
    guide("Prima Cool"),
  ),
  multi('Prima ZOOM',
    antik('', "232.232.64.66"),
    guide("Prima Zoom"),
  ),
  multi('Nova',
    antik('', "232.232.64.63"),
    antik_archive('', 22),
    guide("Nova"),
  ),
  multi('Nova Cinema',
    antik('', "232.232.64.64"),
    guide("Nova Cinema"),
  ),
  multi('Barrandov',
    antik("", "232.232.64.54"),
    guide("Barrandov"),
  ),
  multi('TV Fanda',
    antik('', "232.232.64.119"),
    guide("FANDA"),
  ),
  #multi("Fooor",
  #  dvbt("", "FOOOR", 1003, **f706),
  #  antik('', "232.232.64.86", lang=['sk']),
  #  guide("Fooor"),
  #),
  multi(u'ČT1',
    antik("", "232.232.64.249", port=5002),
    #dvbt("", "CT1", 4001, **f474),
    antik("HD", "232.232.64.10", **dd),
    antik_archive(u'', 15),
    guide(u"CT1"),
  ),
  multi(u'ČT2',
    antik('', "232.232.64.248", port=4998),
    #dvbt("", "CT2", 4002, **f474),
    antik_archive(u'', 24),
    guide(u"CT2"),
  ),
  multi(u'ČT24',
    antik(u'', "232.232.64.111"),
    guide(u'CT24'),
  ),
  
  # Documentary
  multi("Discovery",
    antik("", "232.232.69.6"),
    guide("Discovery"),
  ),
  antik(u"Stil TV", "232.232.64.3", volume=0.3),
  
  # Other
  multi('Prima LOVE',
    antik('', "232.232.64.55"),
    guide("Prima LOVE"),
  ),
  multi(u"JOJ Plus",
    dvbt(u"", "JOJ Plus", 2002, **f778),
    antik(u'', "232.232.64.7"),
    antik('HD', "232.232.64.6", **dd),
    guide("JOJ Plus"),
  ),
  multi(u"Doma",
    dvbt(u"", "Doma", 2004, **f778),
    antik(u'', "232.232.64.253"),
    antik_archive(u'', 120),
    guide("Doma"),
  ),
  multi(u"STV1",
    #dvbt(u"", "STV1", 1003, **f818),
    dvbt(u"", "STV1", 3001, **f506),
    dvbt(u"HD", "STV1 HD", 3003, **f506),
    antik(u"", "232.232.64.1"),
    antik_archive(u"", 18),
    guide("STV1"),
  ),
  multi(u"STV2",
    dvbt(u"", "STV2", 3002, **f506),
    antik(u"", "232.232.64.2"),
    antik_archive(u"", 19),
    guide("STV2"),
  ),
  antik("TV Košice", "232.232.64.124"),

  # Music television channels
  antik("Musiq1", "232.232.64.16"),
  multi("MusicBox/Nasa",
    antik("", "232.232.64.15"),
    dvbt(u"", "TV NASA", 2, **f746),
  ),
  antik(u"Óčko", "232.232.64.14"),
  antik("MTV", "232.232.64.141"),
  antik("VH1", "232.232.65.68"),
  antik(u"Šlágr TV", "232.232.64.73"),
  
  # Animal
  multi("Animal Planet",
    antik("", "232.232.69.7"),
    guide("AnimalPlanet")
  ),
  
  # News
  antik("CNN", "232.232.64.37"),
  antik("BBC World", "232.232.64.38"),
  antik("EuroNews", "232.232.64.39"),

  # S-video
  v4l2("S-video", input=4),
]

CHANNELS = BASIC + CHILDREN

HD = [
  dvbt(u"STV1 HD", "STV1 HD", 3004, deinterlace='discard', **f506),
  antik(u"Markíza HD", "232.232.64.87", **dd),
  antik(u"JOJ HD", "232.232.64.5", **dd),
  antik(u"JOJ Plus HD", "232.232.64.6", **dd),
  antik(u"ČT HD", "232.232.64.10", **dd),
  antik(u"Nova sport HD", "232.232.64.27", **dd),
  antik(u"TV Piánko", "232.232.64.116", **dd),
]

SANET_CHANNELS = [
  # some example SANET channels
  multi(u'Markíza',
    sanet(u'', 70),
    sanet(u'HD', 97, deinterlace="discard"),
    guide("Markiza"),
  ),
  multi('JOJ',
    sanet('', 13),
    sanet('HD', 7, deinterlace="discard"),
    guide("JOJ"),
  ),
  multi('TV Doma',
    sanet('', 92),
    guide("Doma"),
  ),
  multi("JOJ Plus",
    sanet('', 22),
    guide(),
  ),
  multi("Dajto",
    sanet('', 76),
    guide(),
  ),
  multi('STV1',
    sanet('', 71),
    #sanet(u'HD', 9, deinterlace="discard"),
    guide(),
  ),
  multi('STV2',
    sanet('', 72),
    guide()
  ),
  #sanet('STV3', 14),
  multi(u"ČT1",
    sanet("", 81),
    guide("CT1"),
  ),
  multi(u"ČT2",
    sanet("", 82),
    guide("CT2"),
  ),
  sanet('TA3', 11),
  multi('Prima family',
    sanet('', 80),
    guide(),
  ),
  multi("Prima Cool",
    multicast("", "rtp://233.11.36.91:1234/"),
    guide(),
  ),
  multi("Prima Zoom",
    multicast('', "rtp://233.11.36.102:1234/"),
    guide(),
  ),
  multi('Nova',
    multicast('', "rtp://233.11.36.88:1234/"),
    multicast('HD', "rtp://233.11.36.121:1234/", **dd),
    guide(),
  ),
  multi("Nova Cinema",
    multicast("", "rtp://233.11.36.89:1234/"),
    guide(),
  ),
  multi("Fanda",
    multicast("", "rtp://233.11.36.127:1234/"),
    guide("FANDA"),
  ),
  sanet("SANET", 100),
  multi('ZDF',
    sanet('', 17),
    sanet('HD', 95, **dd),
  ),
  sanet('KI.KA', 19),
]

if socket.gethostname()=='work.salstar.sk' or os.environ.get("SANET"):
  screensaver = None
  window_default_size = [456, 365]
  class image_player(media):
    default_player = "imagerefresh"
    def update(self, player=None):
        print 'PLAYER', player, self.url
        import players
        return media.update(self, players.ImageRefreshWidget)
  CHILDREN = SANET_CHANNELS
  #CHANNELS = [] # redefined from local.py

try:
  from local import *
except ImportError, e:
  print "WARNING, local config import error:", e

PROFILES = profiles([
  ["BASIC", CHANNELS],
  ["CHILDREN", CHILDREN],
  ["ROZPRAVKY", filelist(
                  "/home/ondrejj/ln/video/ROZPRAVKY/*",
                  "/home/ondrejj/ln/video/ROZPRAVKY/*/*"
                )],
  ["RADIO", RADIO],
  ["LATEST_MOV", filelist("/home/martin/*.MOV")],
  ["MOV_ARCHIVE", filelist("/home/martin/archiv/*/*/*.MOV")],
  ["LATEST_JPG", filelist("/home/martin/*.JPG")],
  ["JPG_ARCHIVE", filelist("/home/martin/archiv/*/*/*.JPG")],
  ["SAP", sap_list()],
  ["HDTV", HD],
])
