refresh_timeout = 5000;
send_events = true;
refresh_timer = null;
volume_timer = null;
send_timer = null;
browser_path = "";

function update_filelist(flist, counter) {
  var filelist = $("#filelist");
  filelist.empty();
  for (var i in flist) {
    var fn = flist[i];
    var lastchar = fn[fn.length-1];
    var count = counter[fn] || '&nbsp;';
    var element = $('<li><a href="#">'+count+' '+fn+'</a></li>');
    if (lastchar=="/") {
      element.find("a").click(function() {
        $.ajax('browser/'+browser_path+$(this).text().substr(2));
        return false;
      });
    } else {
      element.find("a").click(function() {
        $.ajax('play/'+browser_path+$(this).text().substr(2));
        $("#browser_panel").panel("close");
        return false;
      });
    }
    filelist.append(element);
  }
  filelist.listview("refresh");
}

function request_success(msg) {
  var result = $.parseJSON(msg);
  if (refresh_timer) clearTimeout(refresh_timer);
  //console.log(result);
  send_events = false;
  if (result['mute']) {
    var mute = "on";
  } else {
    var mute = "off";
  }
  if (result['position']!=null) {
    $("#slider_pos").val(result['position']).slider("refresh");
  } else {
    $("#slider_pos").val("?");
  }
  $("#ch-"+result['channel']).attr('checked', 'checked');
  $("input[name=channel]:radio").checkboxradio("refresh");
  $("#channel_name").text(
    result['channel_name']
    +" "+result['source_name']
    +" ["+result['source']+"]"
  );
  $("#channel_position").text(
    "Position: "+result['content_remains']+"/"+result['content_length']
  );
  if (result['filelist']) {
    update_filelist(result['filelist'], result['counter']);
    browser_path = result['filepath'];
  }
  $("f"+result['profile']).attr("data-theme", "e").button("refresh");
  send_events = true;
  // reload and redirection
  if (result['reload_page']) {
    window.location.reload();
  }
  if (result['location']) {
    window.location = result['location'];
  }
  // Wait 0.5s and then update volume if no more values received
  if (volume_timer) {
    clearTimeout(volume_timer);
  } else {
    // update immediatelly first time
    $("#slider_vol").val(result['volume']).slider("refresh");
    $("#volume_mute").val(mute).slider("refresh");
  }
  volume_timer = setTimeout(function() {
    send_events = false;
    $("#slider_vol").val(result['volume']).slider("refresh");
    $("#volume_mute").val(mute).slider("refresh");
    send_events = true;
  }, 500);
  refresh_timer = setTimeout(function() {
    $.ajax("status/");
  }, refresh_timeout);
};

function send_event(event) {
  if (send_events) $.ajax(event);
}

function change_channel(ch) {
  send_event("/channel/"+ch);
}

$(document).ready(function() {
  $.ajaxSetup({
    //cache: false,
    success: request_success
  });

  $("#slider_vol").change(function() {
    var vol = $(this).val();
    if (!send_events) return;
    if (send_timer) clearTimeout(send_timer);
    send_timer = setTimeout(function() {
      send_event("volume/"+vol);
    }, 100);
  });
  $("#volume_mute").change(function() {
    var mute = $(this).val();
    send_event("mute/"+mute);
  });

  $("#slider_pos").change(function() {
    var vol = $(this).val();
    send_event("position/"+vol);
  });
  $("#pos_control").find("a").each(function() {
    $("#"+this.id).click(function() {
      send_event("position/"+this.id);
    });
  });

  // channel management
  $("#profile").find("a").each(function() {
    $("#"+this.id).click(function() {
      send_event("profile/"+this.id[1]);
    });
  });
  $("input[name=channel]:radio").change(function() {
    value = $(this).attr("value");
    send_event("channel/"+value);
  });
  $("#prev").click(function() {
    send_event("channel/prev");
  }); 
  $("#next").click(function() {
    send_event("channel/next");
  });
  $("#last").click(function() {
    send_event("channel/last");
  });
  $("#video_source").click(function() {
    send_event("video/");
  });
  $("#audio_source").click(function() {
    send_event("audio/");
  });
  $("#subtitle").click(function() {
    send_event("subtitle/");
  });

  $("#browser").click(function() {
    send_event("browser/");
  });
  
  $("#youtube_submit").click(function() {
    var search_for = $("#youtube_search").val();
    send_event("youtube/"+encodeURIComponent(search_for));
  });
  
  $("#aspect").click(function() {
    send_event("aspect/");
  });
  $("#fullscreen").click(function() {
    send_event("fullscreen/");
  });
  $("#exit").click(function() {
    send_event("exit/");
  });
  $("#quit").click(function() {
    send_event("quit/");
  });
  
  // initial status and refresh
  $("#refresh").click(function() {
    send_event("status/");
  });
  send_event("status/");
  
  // TV guide
  //$("#tvguide_data").find("a").each(function() {
  //  $(this).click(function() {
  //    send_event(this.href);
  //    $('.ui-dialog').dialog('close');
  //    return false;
  //  });
  //});
});
