'''
SVPlayer path configuration file

(c) 2011 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>     

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
'''

import sys, os.path

# files and paths

if sys.platform.startswith("win"):
  tmpdir = os.path.normpath(os.path.dirname(sys.argv[0]))
  config_file = os.path.join(tmpdir, "svplayer.conf")
  recorder_path = os.path.join(tmpdir, "RECORD")
  file_browser_path = os.path.join(tmpdir, "video")
  last_seen_filename = os.path.join(tmpdir, "last_seen.log")
  history_filename = os.path.join(tmpdir, "svplayer.history")
else:
  tmpdir = os.path.expanduser("/dev/shm")
  config_file = os.path.expanduser("~/.config/svplayer.conf")
  recorder_path = os.path.expanduser("~/ln/video/RECORD")
  file_browser_path = os.path.expanduser("~/ln/video")
  last_seen_filename = os.path.expanduser("~/tmp/last_seen.log")
  history_filename = os.path.expanduser("~/tmp/svplayer.history")

pid_file = os.path.join(tmpdir, os.environ.get('SVPLAYER_PID_FILE', "svplayer.pid"))
fifo_filename = os.path.join(tmpdir, "svplayer.fifo")
cookies_filename = os.path.join(tmpdir, "svplayer.cookies")
recorder_template = os.path.join(recorder_path, "svplayer.tmp.XXXXXX")
