'''
SVPlayer player modules.

(c) 2011-2012 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>     

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
'''

from base import BasePlayerWidget

def GSTWidget(*args, **kw):
    from gstp import GSTWidget
    if not args and not kw:
      return GSTWidget
    return GSTWidget(*args, **kw)

def GSTPlayer(*args, **kw):
    from gstp import GSTPlayer
    if not args and not kw:
      return GSTPlayer
    return GSTPlayer(*args, **kw)

def VLCWidget(*args, **kw):
    from vlcp import VLCWidget
    if not args and not kw:
      return VLCWidget
    return VLCWidget(*args, **kw)

def MPlayerWidget(*args, **kw):
    from mplayerp import MPlayerWidget
    if not args and not kw:
      return MPlayerWidget
    return MPlayerWidget(*args, **kw)

def ImagePlayerWidget(*args, **kw):
    from imagep import ImagePlayerWidget
    if not args and not kw:
      return ImagePlayerWidget
    return ImagePlayerWidget(*args, **kw)

def ImageRefreshWidget(*args, **kw):
    from imagep import ImageRefreshWidget
    if not args and not kw:
      return ImageRefreshWidget
    return ImageRefreshWidget(*args, **kw)

default = GSTWidget

# testing
import os
if os.environ.get("SVPLAYER_GST"):
  default = GSTWidget
elif os.environ.get("SVPLAYER_VLC"):
  default = VLCWidget
