#!/usr/bin/python

import urllib2, time, socket
from xml.dom.minidom import parseString
from xml.parsers.expat import ExpatError

class prog():
  def __init__(self, **kw):
      self.id = kw['id']
      self.name = kw.get('nazev')
      self.description = kw.get('popis')
      self.tv = kw['televize']
      self.category = kw.get('kategorie')
      self.length = kw['delka']
      self.seconds = int(self.length)*60
      self.time = kw['cas']
      self.start = time.mktime(time.strptime(self.time, "%Y-%m-%d %H:%M:%S"))
      self.end = self.start + self.seconds
      self.img = kw.get('img')
  def __repr__(self):
      return u'<prog time=%s, length=%s, name=%s>' \
             % (self.time, self.length, repr(self.name))
  def is_current(self):
      return self.start<=time.time()<self.end
  def progress(self):
      return (time.time()-self.start)/self.seconds

class profi_program_class():
  URL = "http://www.salstar.sk/svplayer/tvguide"
  guide = None
  last_reload = 0
  reload_delta = 60 # seconds
  def reload_current(self):
      if time.time()<self.last_reload+self.reload_delta:
        print "Skipping too fast reload!"
        return
      print "Reloading profi-program.com..."
      self.guide = self.parse(self.URL)
      self.last_reload = time.time()
  def parse(self, url):
      try:
        urlreader = urllib2.urlopen(url, timeout=1)
        source = parseString(urlreader.read()).documentElement
      except socket.timeout:
        return {}
      except urllib2.URLError, e:
        print "urllib error:", str(e)
        return {}
      except ExpatError, e:
        print "XML parse error:", e
        return {}
      guide = {}
      for entry in source.getElementsByTagName("list"):
        nodes = entry.childNodes
        if not nodes:
          continue
        data = {}
        for subentry in nodes:
          element = subentry.childNodes
          if not element:
            continue
          data[subentry.nodeName] = element[0].nodeValue
        if data['televize'] not in guide:
          guide[data['televize']] = {}
        guide[data['televize']][data['cas']] = prog(**data)
      return guide
  def current(self, channel, try_reload=True):
      if self.guide is None:
        self.reload_current()
      if channel in self.guide:
        for value in self.guide[channel].values():
          if value.is_current():
            return value
        if try_reload:
          self.reload_current()
          return self.current(channel, False)
      return None
  def current_name(self, channel):
      current = self.current(channel)
      if current is None:
        return ""
      return current.name

profi_program = profi_program_class()

if __name__ == "__main__":
  print profi_program.current("JOJ")
  print profi_program.current("JOJ").progress()
